(function () {
  'use strict';

  function copyToClipboard(text) {
    var tmp = document.createElement('div');
    tmp.contentEditable = true;
    document.body.appendChild(tmp);
    tmp.textContent = text;
    tmp.unselectable = "off";
    tmp.focus();
    document.execCommand('selectAll');
    document.execCommand("copy", false, null);
    document.body.removeChild(tmp);
  }

  chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if ('set-clipboard' === request.cmd) {
      copyToClipboard(request.text || '');
      sendResponse({cmd: request.cmd, done: true});
    }
  });
})();