(function(ns, $) {

    ns.Detach = function () {
        this.construct.apply(this, arguments);
    };
    var fn = ns.Detach.prototype;

    fn.construct = function () {
        var elements = document.getElementsByClassName('add-comment');
        if (!elements.length) {
            return;
        }
        this.container = elements[0];
        this.comment = $('.comment-textarea');
        this.preview = $('.comment-preview');
        this.detached = false;

        this.detachLink = this.createLink('Detach', this.detachOnClick.bind(this));
        this.attachLink = this.createLink('Attach', this.attachOnClick.bind(this), {style: 'display:none'});
        this.addNode(this.detachLink);
        this.addNode(this.attachLink);
        this.initBoxes();
        this.comment.scroll($.proxy(this.commentOnScroll, this));
        $('.add-comment__btn').click(function () {
          console.log('.add-comment__btn click');
          $(document.body).removeClass('detach');
          setTimeout(function () {
            new app.issue.Detach();
          }, 500);
        });
    };

    fn.initBoxes = function () {
        if (this.detached) {
            var height = $(window).height() - 32;
            $(this.container).css('height', height);
            this.comment.css('height', height/2-100);
            this.preview.css('height', height/2 - 15);
        } else {
            $(this.container).css('height', 'auto');
            this.comment.css('height', 'auto');
            this.preview.css('height', 'auto');
        }
    };

    fn.commentOnScroll = function () {
        if (!this.detached) {
            return;
        }
        var commentHeight = this.comment.get(0).scrollHeight - this.comment.height();
        var previewHeight = this.preview.get(0).scrollHeight - this.preview.height();
        var commentScrollTop = this.comment.scrollTop();
        this.preview.scrollTop(commentScrollTop/commentHeight*previewHeight);
    };

    fn.addNode = function (a) {
        this.container.insertBefore(a, this.container.firstChild);
    };

    fn.createLink = function (text, onclick, attributes) {
        var a = document.createElement('a');
        a.appendChild(document.createTextNode(text));
        a.title = text;
        a.href = '#';
        a.onclick = onclick;
        attributes = attributes || {};
        for (var name in attributes) {
            if (attributes.hasOwnProperty(name)) {
                a.setAttribute(name, attributes[name]);
            }
        }
        return a;
    };

    fn.detachOnClick = function () {
        document.body.className += ' detach';
        this.detachLink.setAttribute('style', "display:none");
        this.attachLink.removeAttribute('style');
        this.detached = true;
        this.initBoxes();
        return false;
    };

    fn.attachOnClick = function () {
        this.attachLink.setAttribute('style', "display:none");
        this.detachLink.removeAttribute('style');
        this.removeClass(document.body, 'detach');
        this.detached = false;
        this.initBoxes();
        return false;
    };

    fn.removeClass = function (node, cls) {
        var regexp = new RegExp('(\\s|^)' + cls + '(\\s|$)');
        node.className = node.className.replace(regexp, ' ');
    };

})(o35.defineNS('app.issue'), Zepto);
