(function (o35, $) {
  'use strict';

  o35.debug = true;

  var href = window.location.href;
  o35.youtrackUrl = href.substring(0, href.lastIndexOf('/issue/'));

  o35.wikiBaseUrl = 'https://work.adaptainc.com/wiki';
  o35.baseUrl = 'https://my.orange35.com/clarity'; 

  // if (o35.debug) {
  //   o35.baseUrl = 'https://riddler.dev.orange35.com/clarity/trunk/public';
  // }

  o35.pluginsBaseUrl = o35.baseUrl + '/plugins';

  o35.getType = function (mixed, lowerCase) {
    var type = (null === mixed || undefined === mixed)
      ? '' + mixed
      : Object.prototype.toString.call(mixed).slice(8, -1);
    return (lowerCase) ? type.toLowerCase() : type;
  };

  o35.defineNS = function (name) {
    "use strict";
    var i, c, type, path = ('' + name).split('.'), target = window;
    for (i = 0, c = path.length; i < c; ++i) {
      type = this.getType(target[path[i]]);
      if ('undefined' === type) {
        target[path[i]] = {};
        target = target[path[i]];
      } else if ('Object' === type) {
        target = target[path[i]];
      } else {
        throw new TypeError('Wrong namespace "' + name + '" segment type {' + type + '} ' + path[i]);
      }
    }
    return target;
  };

  o35.escapeHtml = function (string) {
    var entityMap = {
      '&': '&amp;',
      '<': '&lt;',
      '>': '&gt;',
      '"': '&quot;',
      "'": '&#39;',
      '/': '&#x2F;'
    };
    return String(string).replace(/[&<>"'\/]/g, function (s) {
      return entityMap[s];
    });
  };

  o35.prepareLink = function (href, base) {
    if (!base) {
      return href;
    }
    href = '' + href;
    if (/:\/\//.test(href)) {
      return href;
    }
    return base.replace(/\/$/, '') + '/' + href.replace(/^\//, '');
  };

  o35.loadStylesheet =function (href) {
    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = href;
    link.media = 'all';
    document.head.appendChild(link);
  };

  o35.setClipboard = function (text) {
    chrome.extension.sendMessage({cmd: 'set-clipboard', text: text}, function (response) {});
  };

})(window.o35 = {}, Zepto);
